Topological data scripting

From FreeCAD Documentation

Introduction

We will here explain you how to control the Part Module directly from the FreeCAD python interpreter, or from any external script. Be sure to browse the Scripting section and the FreeCAD Scripting Basics pages if you need more information about how python scripting works in FreeCAD.

First to use the Part module functionality you have to load the Part module into the interpreter: import Part

Class Diagram

This is a UML overview about the most important classes of the Part module:

Python classes of the Part module
Python classes of the Part module

Geometry

The geomtric objects are the building block of all topological objects:

  • GEOM Base class of the geometric objects
  • LINE A straight line in 3D, defined by starting point and and point
  • CIRCLE Circle or circle segment defined by a center point and start and end point
  • ...... And soon some more ;-)

Topology

The following topological data types are available:

  • COMPOUND A group of any type of topological object.
  • COMPSOLID A composite solid is a set of solids connected by their faces. It expands the notions of WIRE and SHELL to solids.
  • SOLID A part of space limited by shells. It is three dimensional.
  • SHELL A set of faces connected by their edges. A shell can be open or closed.
  • FACE In 2D it is part of a plane; in 3D it is part of a surface. Its geometry is constrained (trimmed) by contours. It is two dimensional.
  • WIRE A set of edges connected by their vertices. It can be an open or closed contour depending on whether the edges are linked or not.
  • EDGE A topological element corresponding to a restrained curve. An edge is generally limited by vertices. It has one dimension.
  • VERTEX A topological element corresponding to a point. It has zero dimension.
  • SHAPE A generic term covering all of the above.

Creating basic types

First import the following:


>>> import Part
>>> from FreeCAD import Base

1) How to create a Vertex?


>>> vertex = Part.Vertex((1,0,0))

vertex is a point created at x=1,y=0,z=0 given a vertex object you can find its location like this:


>>> vertex.Point
Vector (1, 0, 0)

2) How to create an Edge?

An edge is nothing but a line with two vertexes


>>> edge = Part.makeLine((0,0,0), (10,0,0))
>>> edge.Vertexes
[<Vertex object at 01877430>, <Vertex object at 014888E0>]

Note: You cannot create an Edge by passing two vertexes you can find the length and center of an edge like this:


>>> edge.Length
10.0
>>> edge.CenterOfMass
Vector (5, 0, 0)

3) How to create a Wire?

A wire can be created from a list of edges or list of wires even


>>> edge1 = Part.makeLine((0,0,0), (10,0,0))
>>> edge2 = Part.makeLine((10,0,0), (10,10,0))
>>> wire1 = Part.Wire([edge1,edge2]) 
>>> edge3 = Part.makeLine((10,10,0), (0,10,0))
>>> edge4 = Part.makeLine((0,10,0), (0,0,0))
>>> wire2 = Part.Wire([edge3,edge4])
>>> wire3 = Part.Wire([wire1,wire2])
>>> wire3.Edges
[<Edge object at 016695F8>, <Edge object at 0197AED8>, <Edge object at 01828B20>, 
 <Edge object at 0190A788>]
>>> Part.show(wire3)

Part.show(wire3) will display four lines as a square


>>> wire3.Length
40.0
>>> wire3.CenterOfMass
Vector (5, 5, 0)
>>> wire3.isClosed()
True
>>> wire2.isClosed()
False

4) How to create a Face?

Face created on a closed wire is only valid wire3 is a closed wire but wire2 is not a closed wire (see above)


>>> face = Part.Face(wire3)
>>> face.Area
99.999999999999972
>>> face.CenterOfMass
Vector (5, 5, 0)
>>> face.Length
40.0
>>> face.isValid()
True
>>> sface = Part.Face(wire2)
>>> face.isValid()
False

Only a face will have an area but not a wire or an edge

5) How to create a circle?

circle = Part.makeCircle(radius,[center,dir_normal,angle1,angle2]) -- Make a circle with a given radius By default center=Vector(0,0,0), dir_normal=Vector(0,0,1), angle1=0 and angle2=2*PI Circle can be created as simple as this:


>>> circle = Part.makeCircle(10)
>>> circle.Curve
Circle (Radius : 10, Position : (0, 0, 0), Direction : (0, 0, 1))

if you want to create it at certain position and with certain direction


>>> ccircle = Part.makeCircle(10, Base.Vector(10,0,0), Base.Vector(1,0,0))
>>> ccircle.Curve
Circle (Radius : 10, Position : (10, 0, 0), Direction : (1, 0, 0))

ccircle will be created at distance 10 from origin on x and will be facing towards x axis Note: makeCircle only accepts Base.Vector() for position and normal but not tuples you can also create part of the circle by giving start Angle and end Angle as:


>>> from math import pi
>>> arc1 = Part.makeCircle(10, Base.Vector(0,0,0), Base.Vector(0,0,1), 0, pi)
>>> arc2 = Part.makeCircle(10, Base.Vector(0,0,0), Base.Vector(0,0,1), pi, 2*pi)

both arc1 and arc2 jointly will make a circle angles should be provided in radians, if you have degrees simply convert them using formula radians = degrees * PI/180

6) How to create an Arc along points?

unfortunately there is no makeArc function but we have Part.Arc function to create an arc along three points basically it can be supposed as an arc joining start point and end point along the middle point Part.Arc creates an arc object on which .toShape() has to be called to get the edge object, which is generally produced by makeLine or makeCircle


>>> arc = Part.Arc(Base.Vector(0,0,0),Base.Vector(0,5,0),Base.Vector(5,5,0))
>>> arc
<Arc object>
>>> arc_edge = arc.toShape()

Note: Arc only accepts Base.Vector() for points but not tuples arc_edge is what we want which we can display using Part.show(arc_edge) if you want a small portion of a circle as an arc, its possible


>>> from math import pi
>>> circle = Part.Circle(Base.Vector(0,0,0),Base.Vector(0,0,1),10)
>>> arc = Part.Arc(c,0,pi)

7) How to create a polygon or line along points?

a line along multiple points is nothing but creating a wire with multiple edges makePolygon function takes a list of points and creates a wire along those points


>>> lshape_wire = Part.makePolygon([Base.Vector(0,5,0),Base.Vector(0,0,0),Base.Vector(5,0,0)])

8) How to create a plane?

Plane is a flat surface, meaning a face in 2D makePlane(length,width,[start_pnt,dir_normal]) -- Make a plane By default start_pnt=Vector(0,0,0) and dir_normal=Vector(0,0,1) dir_normal=Vector(0,0,1) will create the plane facing z axis dir_normal=Vector(1,0,0) will create the plane facing x axis


>>> plane = Part.makePlane(2,2)
>>> plane
<Face object at 028AF990>
>>> plane = Part.makePlane(2,2, Base.Vector(3,0,0), Base.Vector(0,1,0))
>>> plane.BoundBox
BoundBox (3, 0, 0, 5, 0, 2)

BoundBox is a cuboid enclosing the plane with a diagnol starting at (3,0,0) and ending at (5,0,2) here the BoundBox thickness in y axis is zero Note: makePlane only accepts Base.Vector() for start_pnt and dir_normal but not tuples

9) How to create an ellipse?

To create an ellipse there are several ways:

Part.Ellipse() Creates an ellipse with major radius 2 and minor radius 1 with the center in (0,0,0)

Part.Ellipse(Ellipse) Create a copy of the given ellipse

Part.Ellipse(S1,S2,Center) Creates an ellipse centered on the point Center, where the plane of the ellipse is defined by Center, S1 and S2, its major axis is defined by Center and S1, its major radius is the distance between Center and S1, and its minor radius is the distance between S2 and the major axis.

Part.Ellipse(Center,MajorRadius,MinorRadius) Creates an ellipse with major and minor radii MajorRadius and MinorRadius, and located in the plane defined by Center and the normal (0,0,1)


>>> eli = Part.Ellipse(Base.Vector(10,0,0),Base.Vector(0,5,0),Base.Vector(0,0,0))
>>> Part.show(eli.toShape())

In the above code we have passed S1, S2 and center similar to Arc, Ellipse also creates an Ellipse object but not Edge, so we need to convert it into Edge using toShape() to display

Note: Arc only accepts Base.Vector() for points but not tuples


>>> eli = Part.Ellipse(Base.Vector(0,0,0),10,5)
>>> Part.show(eli.toShape())

for the above Ellipse function we have passed center, MajorRadius and MinorRadius

10) How to create a Torus?

makeTorus(radius1,radius2,[pnt,dir,angle1,angle2,angle]) -- Make a torus with a given radii and angles By default pnt=Vector(0,0,0),dir=Vector(0,0,1),angle1=0,angle1=2*PI and angle=2*PI

consider torus as small circle sweeping along a big circle

radius1 is the radius of big cirlce, radius2 is the radius of small circle pnt is the center of torus and dir is the normal direction angle1 and angle2 are angles in radians for the small circle, to create an arc the last parameter angle is to make a section of the torus


>>> torus = Part.makeTorus(10, 2)

above code will create a torus with diameter 20(radius 10) and thickness 4(small cirlce radius 2)


>>> tor=Part.makeTorus(10,5,Base.Vector(0,0,0),Base.Vector(0,0,1),0,pi)

above code will create a slice of the torus


>>> tor=Part.makeTorus(10,5,Base.Vector(0,0,0),Base.Vector(0,0,1),0,2*pi,pi)

above code will create a semi torus, only the last parameter is changed i.e the angle and remaining angles are defaults

giving the angle pi will create the torus from 0 to pi i.e half

11) How to make a box or cuboid?

makeBox(length,width,height,[pnt,dir]) -- Make a box located in pnt with the dimensions (length,width,height)

By default pnt=Vector(0,0,0) and dir=Vector(0,0,1)


>>> box = Part.makeBox(10,10,10)
>>> len(box.Vertexes)
8

12) How to make a Sphere?

makeSphere(radius,[pnt, dir, angle1,angle2,angle3]) -- Make a sphere with a given radius By default pnt=Vector(0,0,0), dir=Vector(0,0,1), angle1=-0.5*PI, angle2=0.5*PI and angle3=2*PI angle1 and angle2 are the vertical minimum and maximum of the sphere angle3 is the sphere diameter itself


>>> sphere = Part.makeSphere(10)
>>> hemisphere = Part.makeSphere(10,Base.Vector(0,0,0),Base.Vector(0,0,1),-pi/2,pi/2,pi)

13) How to make a Cylinder?

makeCylinder(radius,height,[pnt,dir,angle]) -- Make a cylinder with a given radius and height

By default pnt=Vector(0,0,0),dir=Vector(0,0,1) and angle=2*PI


>>> cylinder = Part.makeCylinder(5,20)
>>> partCylinder = Part.makeCylinder(5,20,Base.Vector(20,0,0),Base.Vector(0,0,1),pi)

14) How to make a Cone?

makeCone(radius1,radius2,height,[pnt,dir,angle]) -- Make a cone with given radii and height

By default pnt=Vector(0,0,0), dir=Vector(0,0,1) and angle=2*PI


>>> cone = Part.makeCone(10,0,20)
>>> semicone = Part.makeCone(10,0,20,Base.Vector(20,0,0),Base.Vector(0,0,1),pi)

In short:

You can easily create basic topological objects with the "make...()" methods from the Part Module:

b = Part.makeBox(0,0,0,100,100,100)
Part.show(b)

A couple of other make...() methods available:

  • makeBox(x,y,z,l,w,h) -- Make a box located in (x,y,z) with the dimensions (l,w,h)
  • makeCircle(radius,[angle1,angle2]) -- Make a circle with a given radius. By default angle1=0 and angle2=2*PI
  • makeCompound(list) -- Create a compound out of a list of geometries
  • makeCylinder(radius,height,[angle]) -- Make a cylinder with a given radius and height. By default angle=2*PI
  • makeLine((x1,y1,z1),(x2,y2,z2)) -- Make a line of two points
  • makePlane(lenght,width) -- Make a plane
  • makePolygon(list) -- Make a polygon of a list of points
  • makeSphere(radius,[angle1,angle2,angle3]) -- Make a sphere with a given radius. By default angle1=0, angle2=0.5*PI and angle3=2*PI

Exploring shapes

You can easily explore the topological data structure:

b = Part.makeBox(0,0,0,100,100,100)
b.Wires
w = b.Wires[0]
w
w.Wires
w.Vertexes
Part.show(w)
w.Edges
e = w.Edges[0]
e.Vertexes
v = e.Vertexes[0]
v.Point

By typing the line above in the python interpreter, you will gain a good understanding of the structure of Part objects. Here, our makeBox() command created a solid shape. This solid, like all Part solids, contains faces. Faces always contain wires, which are lists of edges that border the face. Each face has exactly one closed wire. In the wire, we can look at each edge separately, and inside each edge, we can see the vertexes. Straight edges have only two vertexes, obviously. Part Vertexes are OCC shapes, but they have a Point attribute which returns a nice FreeCAD Vector.

Example 1: Creating simple topology

Wire
Wire

We will now create a topology by constructing it out of simpler geometry. As a case study we use a part as seen in the picture which consists of four vertexes, two circles and two lines.

Creating Geometry

First we have to create the distinct geometric parts of this wire. And we have to take care that the vertexes of the geometric parts are at the same position. Otherwise later on we might not be able to connect the geometric parts to a topology!

So we create first the points:

from FreeCAD import Base
V1 = Base.Vector(0,10,0)
V2 = Base.Vector(30,10,0)
V3 = Base.Vector(30,-10,0)
V4 = Base.Vector(0,-10,0)

Arc

Circle
Circle

To create an arc of circle we make a helper point and create the arc of circle through three points:

VC1 = Base.Vector(-10,0,0)
C1 = Part.Arc(V1,VC1,V4)
# and the second one
VC2 = Base.Vector(40,0,0)
C2 = Part.Arc(V2,VC2,V3)

Line

Line
Line

The line can be created very simple out of the points:

L1 = Part.Line(V1,V2)
# and the second one
L2 = Part.Line(V4,V3)

Putting all together

The last step is to put the geometric base elements together and bake a topological shape:

S1 = Part.Shape([C1,C2,L1,L2])

Make a prism

Now extrude the wire in a direction and make an actual 3D shape:

W = Part.Wire(S1.Edges)
P = W.extrude(Base.Vector(0,0,10))

Example 2: The OCC bottle

A typical example found on the OpenCasCade Getting Started Page is how to build a bottle. This is a good exercise for FreeCAD too. In fact, you can follow our example below and the OCC page simultaneously, you will understand well how OCC structures are implemented in FreeCAD.

The complete script below is also included in FreeCAD installation (inside the Mod/Part folder) and can be called from the python interpreter by typing:

import Part
import MakeBottle
bottle = MakeBottle.makeBottle()
Part.show(bottle)

The complete script

Here is the complete MakeBottle script:

import Part, FreeCAD, math
from FreeCAD import Base

def makeBottle(myWidth=50.0, myHeight=70.0, myThickness=30.0):
   aPnt1=Base.Vector(-myWidth/2.,0,0)
   aPnt2=Base.Vector(-myWidth/2.,-myThickness/4.,0)
   aPnt3=Base.Vector(0,-myThickness/2.,0)
   aPnt4=Base.Vector(myWidth/2.,-myThickness/4.,0)
   aPnt5=Base.Vector(myWidth/2.,0,0)
   
   aArcOfCircle = Part.Arc(aPnt2,aPnt3,aPnt4)
   aSegment1=Part.Line(aPnt1,aPnt2)
   aSegment2=Part.Line(aPnt4,aPnt5)
   aEdge1=aSegment1.toShape()
   aEdge2=aArcOfCircle.toShape()
   aEdge3=aSegment2.toShape()
   aWire=Part.Wire([aEdge1,aEdge2,aEdge3])
   
   aTrsf=Base.Matrix()
   aTrsf.rotateZ(math.pi) # rotate around the z-axis
   
   aMirroredWire=aWire.transform(aTrsf)
   myWireProfile=Part.Wire([aWire,aMirroredWire])
   myFaceProfile=Part.Face(myWireProfile)
   aPrismVec=Base.Vector(0,0,myHeight)
   myBody=myFaceProfile.extrude(aPrismVec)
   myBody=myBody.makeFillet(myThickness/12.0,myBody.Edges)
   neckLocation=Base.Vector(0,0,myHeight)
   neckNormal=Base.Vector(0,0,1)
   myNeckRadius = myThickness / 4.
   myNeckHeight = myHeight / 10
   myNeck = Part.makeCylinder(myNeckRadius,myNeckHeight,neckLocation,neckNormal)	
   myBody = myBody.fuse(myNeck)
   
   faceToRemove = 0
   zMax = -1.0
   
   for xp in myBody.Faces:
       try:
           surf = xp.Surface
           if type(surf) == Part.Plane:
               z = surf.Position.z
               if z > zMax:
                   zMax = z
                   faceToRemove = xp
       except:
           continue
   
   myBody = myBody.makeThickness([faceToRemove],-myThickness/50 , 1.e-3)
   
   return myBody

Detailed explanation

import Part, FreeCAD, math
from FreeCAD import Base

We will need,of course, the Part module, but also the FreeCAD.Base module, which contains basic FreeCAD structures like vectors and matrixes.

def makeBottle(myWidth=50.0, myHeight=70.0, myThickness=30.0):
   aPnt1=Base.Vector(-myWidth/2.,0,0)
   aPnt2=Base.Vector(-myWidth/2.,-myThickness/4.,0)
   aPnt3=Base.Vector(0,-myThickness/2.,0)
   aPnt4=Base.Vector(myWidth/2.,-myThickness/4.,0)
   aPnt5=Base.Vector(myWidth/2.,0,0)

Here we define our makeBottle function. This function can be called without arguments, like we did above, in which case default values for width, height, and thickness will be used. Then, we define a couple of points that will be used for building our base profile.

   aArcOfCircle = Part.Arc(aPnt2,aPnt3,aPnt4)
   aSegment1=Part.Line(aPnt1,aPnt2)
   aSegment2=Part.Line(aPnt4,aPnt5)

Here we actually define the geometry: an arc, made of 3 points, and two line segments, made of 2 points.

   aEdge1=aSegment1.toShape()
   aEdge2=aArcOfCircle.toShape()
   aEdge3=aSegment2.toShape()
   aWire=Part.Wire([aEdge1,aEdge2,aEdge3])

Remember the difference between geometry and shapes? Here we build shapes out of our construction geometry. 3 edges (edges can be straight or curved), then a wire made of those three edges.

   aTrsf=Base.Matrix()
   aTrsf.rotateZ(math.pi) # rotate around the z-axis
   aMirroredWire=aWire.transform(aTrsf)
   myWireProfile=Part.Wire([aWire,aMirroredWire])

Until now we built only a half profile. Easier than building the whole profile the same way, we can just mirror what we did, and glue both halfs together. So we first create a matrix. A matrix is a very common way to apply transformations to objects in the 3D world, since it can contain in one structure all basic transformations that 3D objects can suffer (move, rotate and scale). Here, after we create the matrix, we mirror it, and we create a copy of our wire with that transformation matrix applied to it. We now have two wires, and we can make a third wire out of them, since wires are actually lists of edges.

   myFaceProfile=Part.Face(myWireProfile)
   aPrismVec=Base.Vector(0,0,myHeight)
   myBody=myFaceProfile.extrude(aPrismVec)
   myBody=myBody.makeFillet(myThickness/12.0,myBody.Edges)

Now that we have a closed wire, it can be turned into a face. Once we have a face, we can extrude it. Doing so, we actually made a solid. Then we apply a nice little fillet to our object because we care about good design, don't we?

   neckLocation=Base.Vector(0,0,myHeight)
   neckNormal=Base.Vector(0,0,1)
   myNeckRadius = myThickness / 4.
   myNeckHeight = myHeight / 10
   myNeck = Part.makeCylinder(myNeckRadius,myNeckHeight,neckLocation,neckNormal)	

Then, the body of our bottle is made, we still need to create a neck. So we make a new solid, with a cylinder.

   myBody = myBody.fuse(myNeck)

The fuse operation, which in other apps is sometimes called union, is very powerful. It will take care of gluing what needs to be glued and remove parts that need to be removed.

   return myBody

Then, we return our Part solid as the result of our function. That Part solid, like any other Part shape, can be attributed to an object in a FreeCAD document, with:

myObject = FreeCAD.ActiveDocument.addObject("Part::Feature","myObject")
myObject.Shape = bottle

or, more simple:

Part.show(bottle)

Load and Save

There are several ways to save your work in the Part module. You can of course save your FreeCAD document, but you can also save Part objects directly to common CAD formats, such as BREP, IGS, STEP and STL.

Saving a shape to a file is easy. There are exportBrep(), exportIges(), exportStl() and exportStep() methods availables for all shape objects. So, doing:

import Part
s = Part.makeBox(0,0,0,10,10,10)
s.exportStep("test.stp")

this will save our box into a STEP file. To load a BREP, IGES or STEP file, simply do the contrary:

import Part
s = Part.Shape()
s.read("test.stp")

Note that importing or opening BREP, IGES or STEP files can also be done directly from the File -> Open or File -> Import menu. At the moment exporting is still not possible that way, but should be there soon.